/* START_LICENSE_HEADER

Copyright (C) 2000 Martin Piper, original design and program code
Copyright (C) 2001-2005 Replica Software

This program file is copyright (C) Replica Software and can only be used under license.
For more information visit: http://www.replicanet.com/
Or email: info@replicanet.com

END_LICENSE_HEADER */
#ifndef __DLLEXPORTAPI_H__
#define __DLLEXPORTAPI_H__

// These defines are here at the top-level so that they can be enabled by the user.
// In an ideal world people will use the preprocessor define method, but in some cases the preprocessor defines cannot be changed.
// Define this to enable ReplicaNet Visual Debugger information.
//#define REPLICANET_VISUALDEBUGGER
// Define this to disable all memory tracking, disable all overrides to new/delete/malloc/free/calloc/realloc
//#define REPLICANET_NOMEMORYTRACKING
// Define this to always include "RNPlatform/Inc/MemoryTracking.h"
//#define REPLICANET_ALWAYSDOMEMORYTRACKING

// This pragma removes the harmless warning from MSVC about browse information and the STL 
#ifdef _MSC_VER
#pragma warning(disable : 4786)
#endif

#if defined(_WIN32)

// Remove some harmless warnings
#pragma warning(disable: 4275)
#pragma warning(disable: 4251)

// Rules for creating DLL export/import or static LIB version of this library
#ifdef DOREPNETEXPORTAPI

#ifdef DOREPNETEXPORTAPIDEFS
#define REPNETEXPORTAPI __declspec(dllexport)
#else
#define REPNETEXPORTAPI __declspec(dllimport)
#endif
#ifdef XPURLDLL_EXPORTS
#define XPURLDLL_API __declspec(dllexport)
#else
#define XPURLDLL_API __declspec(dllimport)
#endif
#ifdef XPSESSIONDLL_EXPORTS
#define XPSESSIONDLL_API __declspec(dllexport)
#else
#define XPSESSIONDLL_API __declspec(dllimport)
#endif
#ifdef REPLICANETDLL_EXPORTS
#define REPLICANETDLL_API __declspec(dllexport)
#else
#define REPLICANETDLL_API __declspec(dllimport)
#endif

// If we are in DLL mode then auto-include the memory tracking if we can
#ifndef REPLICANET_NOAUTOMATICINCLUDEMEMORYTRACKING
#include "RNPlatform/Inc/MemoryTracking.h"
#endif

#else	// ifdef DOREPNETEXPORTAPIDEFS

#define REPNETEXPORTAPI
#define XPURLDLL_API
#define XPSESSIONDLL_API
#define REPLICANETDLL_API
#endif


//////////////////////////////////////////////////////
#else	// if defined(_WIN32)
//////////////////////////////////////////////////////

#define REPNETEXPORTAPI
#define XPURLDLL_API
#define XPSESSIONDLL_API
#define REPLICANETDLL_API

#endif

#ifdef REPLICANET_ALWAYSDOMEMORYTRACKING
#include "RNPlatform/Inc/MemoryTracking.h"
#endif


#endif
