/* START_LICENSE_HEADER

Copyright (C) 2000 Martin Piper, original design and program code
Copyright (C) 2001-2005 Replica Software

This program file is copyright (C) Replica Software and can only be used under license.
For more information visit: http://www.replicanet.com/
Or email: info@replicanet.com

END_LICENSE_HEADER */
#ifndef __SYSTIME_H__
#define __SYSTIME_H__
#include "RNPlatform/Inc/DLLExportAPI.h"

#if defined(_XBOX)
#include <xtl.h>			// For XBox builds
#else
#if defined(_WIN32)
#include <windows.h>		// For Windows builds
#endif
#endif

#if defined(_PS2)
#include <eekernel.h>
#endif

namespace RNReplicaNet
{

/**
 * Enables a high performance timer to be used
 */
class REPNETEXPORTAPI SysTime
{
public:

	/**
	 * The ctor performs some basic initialisation
	 */
	SysTime();

	/**
	 * The dtor makes sure everything is tidy
	 */
	virtual ~SysTime();

	/**
	 * Read the current time and return the time as a float
	 */
	float		FloatTime(void);

private:
#if defined(_WIN32)
	double		pfreq;
	double		curtime;
	double		lastcurtime;
	int			lowshift;
	int			sametimecount;
	unsigned int	oldtime;


	LARGE_INTEGER startticktime;
	LARGE_INTEGER	PerformanceFreq;
#endif
#if defined(_PS2)
	u_long mPS2Initial;
#endif
	int			first;
	unsigned int mBaseTickCount;
	int		mSecBase;
};

} // namespace RNReplicaNet

#endif //#ifndef __SYSTIME_H__
