/* START_LICENSE_HEADER

Copyright (C) 2000 Martin Piper, original design and program code
Copyright (C) 2001-2005 Replica Software

This program file is copyright (C) Replica Software and can only be used under license.
For more information visit: http://www.replicanet.com/
Or email: info@replicanet.com

END_LICENSE_HEADER */
#ifndef _CHECKSUM_H_
#define _CHECKSUM_H_
#include "RNPlatform/Inc/DLLExportAPI.h"

namespace RNReplicaNet
{

/**
 * This class handles simple checking of data blocks
 */
class REPNETEXPORTAPI Checksum
{
public:
	/**
	 * Performs a simple and quick checksum of a buffer
	 * \param buffer the data buffer to checksum
	 * \param the length of the data buffer in bytes
	 * \return the checksum for the data, the checksum returned is never 0
	 */
	static int ChecksumData(const char *buffer,const int length);

private:
	Checksum(){}
	virtual ~Checksum(){}
};

} // namespace RNReplicaNet

#endif
