/* START_LICENSE_HEADER

Copyright (C) 2000 Martin Piper, original design and program code
Copyright (C) 2001-2005 Replica Software

This program file is copyright (C) Replica Software and can only be used under license.
For more information visit: http://www.replicanet.com/
Or email: info@replicanet.com

END_LICENSE_HEADER */
#ifndef __PLATFORMINFO_H__
#define __PLATFORMINFO_H__
#include "RNPlatform/Inc/DLLExportAPI.h"

namespace RNReplicaNet
{

/**
 * A class designed to read various platform specific attributes
 */
class REPNETEXPORTAPI PlatformInfo
{
public:
	/**
	 * Supplies information on if the library is compiled with threading on or off.
	 * \return returns true if threading is turned on
	 */
	static bool IsThreaded(void);

	/**
	 * Tests for endianness of the machine
	 * \return returns true for little endian machines
	 */
	static bool IsLittleEndian(void);

	/**
	 * Sets if threads are allowed on this system. Allowing threads with single threaded libraries may result in unexpected results.
	 * \param allow true means allow threads, false does not allow threads
	 */
	static void SetThreaded(const bool allow);

};

} // namespace RNReplicaNet

#endif
